# ybook-back\.gitlab-ci.yml

stages:
  - build
  - test
  - docker-build
  - deploy
  
variables:
  IMAGE_TAG: $CI_COMMIT_REF_SLUG
  IMAGE_NAME: ybook-back

build:
  stage: build
  image: node
  script: 
    - echo "Start building App"
    - npm install
    - npm run build
    - echo "Build successfully!"
  artifacts:
    expire_in: 1 hour
    paths:
      - build 
      - node_modules/
      - docker-compose.yml
  tags:
  - docker

test:
  stage: test
  image: node
  script:
    - echo "Testing App"
    - CI=true npm test
    - echo "Test successfully!"
  tags:
  - docker

docker-build:
  stage: docker-build
  image: docker:latest
  services: 
    - name: docker:19.03.8-dind
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - echo "Building docker image"
    - docker build -t "$CI_REGISTRY_IMAGE:$IMAGE_TAG" .
    - docker push "$CI_REGISTRY_IMAGE:$IMAGE_TAG"
    - echo "Docker image successfully built!"
    - echo "Image :\ $CI_REGISTRY_IMAGE:$IMAGE_TAG"
  only:
    - main
    - master  
  tags:
    - docker
  
deploy:
  stage: deploy
  image: kroniak/ssh-client
  before_script:
    - echo "Deploying the App to Digital Ocean"   
  script:
    - chmod 400 $SSH_KEY
    - ssh -o StrictHostKeyChecking=no -i $SSH_KEY root@$SERVER_IP "docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY"
    - scp -o StrictHostKeyChecking=no -i $SSH_KEY docker-compose.yml root@$SERVER_IP:/root
    - ssh -o StrictHostKeyChecking=no -i $SSH_KEY root@$SERVER_IP "docker-compose up -d"
    - ssh -o StrictHostKeyChecking=no -i $SSH_KEY root@$SERVER_IP "docker-compose"
    - echo "App successfully deployed!"
    - echo "App URL :\ http://$SERVER_IP"
  only:
    - main
    - master
  tags:
    - docker  
  
